<?php
/*------------------------------------------------------------------------
# plg_123formbuilder.php - 123FormBuilder Replace CodeID Plugin
# ------------------------------------------------------------------------
# author    123FormBuilder
# copyright Copyright (C) 2008-2012 123formbuilder.com. All Rights Reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Websites: http://www.123formbuilder.com
-------------------------------------------------------------------------*/
// no direct access
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgContent123FormBuilder extends JPlugin
{

    /**
     * plgContent123FormBuilder constructor.
     * @param $subject
     * @param $config
     */
    function __construct(&$subject, $config)
    {
        parent::__construct($subject, $config);
    }

    /**
     * @param     $row
     * @param     $params
     * @param int $page
     * @return bool
     */
    public function onPrepareContent(&$row, &$params, $page = 0)
    {
        if (is_object($row)) {
            $articleText = &$row->text;
        } else {
            $articleText = &$row;
        }

        $domain = 'www.123formbuilder.com';
        if (strpos($articleText, '[123-form-builder-eu') !== false) {
            $i = strpos($articleText, "[123-form-builder-eu ");
            $domain = 'eu.123formbuilder.com';
        } elseif (strpos($articleText, '[123-contact-form-eu') !== false) {
            $i = strpos($articleText, "[123-contact-form-eu ");
            $domain = 'eu.123formbuilder.com';
        } else {
            $i = strpos($articleText, "[123-form-builder ");
            if ($i === false) {
                $i = strpos($articleText, "[123-contact-form ");
            }
        }


        if ($i !== false) {
            $customVars2 = '';
            $j = strpos($articleText, "]", $i);
            if ($j === false) return $content; /* form code not closed correctly */
            $pos_custom_controls = strpos($articleText, "control", $i + 19);
            if (($pos_custom_controls > $i) && ($pos_custom_controls < $j)) {//If we face some custom vars inside the WP-content page
                $pos1 = stripos($articleText, "i", $i);
                $pos2 = stripos($articleText, "control", $i);
                $id = substr($articleText, $pos1, $pos2 - $pos1);
                $id = str_replace("i", "", $id);
                $id = str_replace(" ", "", $id);
                $id = intval($id);
                $customVars2 = substr($articleText, $pos2, $j - $pos2);
                $customVars2 = str_replace("'", "", $customVars2);
                $customVars2 = str_replace('"', '', $customVars2);
            } else
                if (strpos($articleText, '[123-form-builder-eu') !== false)
                    $id = substr($articleText, $i + 22, $j - $i - 22);
                else
                    $id = substr($articleText, $i + 19, $j - $i - 19);


            if (is_numeric($id)) {
                $toreplace = substr($articleText, $i, $j - $i + 1);

                $formURL = "//" . $domain . "/embed/" . $id . ".js";
                $formcode = "<script type=\"text/javascript\" defer src=\"$formURL\" data-role=\"form\" data-default-width=\"650px\"></script>";

                $articleText = str_replace($toreplace, $formcode, $articleText);

                if (is_callable('curl_init')) {
                    $curl = curl_init("http://" . $domain . "/embedded-jlink/" . $id . ".txt");
                    curl_setopt($curl, CURLOPT_HEADER, 0);
                    ob_start();
                    curl_exec($curl);
                    curl_close($curl);
                    $linkcode = ob_get_contents();
                    ob_end_clean();
                } elseif (is_callable('file_get_contents')) {
                    $linkcode = file_get_contents("http://" . $domain . "/embedded-jlink/" . $id . ".txt");
                }
                $articleText .= $linkcode;
            }
        }
        return true;
    }
}
